package mv3302;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;
import simkit.stat.SimpleStatsTally;

/**
 *
 * @author dansl
 */
public class TransientStats implements PropertyChangeListener {

    private final String state;
    
    protected List<SimpleStatsTally> data;
    
    protected int nextObs;
    
    public TransientStats(String state) {
        this.state = state;
        data = new ArrayList<>();
        nextObs = 0;
    }
    
    
    public void reset() {
        nextObs = 0;
    }
    
    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        if (!evt.getPropertyName().equals(state)) {
            return;
        }
        if (nextObs >= getRawData().size()) {
            data.add(new SimpleStatsTally("Data " + nextObs));
        }
        if (evt.getNewValue() instanceof Number) {
            data.get(nextObs).newObservation(((Number)evt.getNewValue()).doubleValue());
        }
        nextObs += 1;
    }

    /**
     * @return the data
     */
    public List<SimpleStatsTally> getRawData() {
        return new ArrayList<>(data);
    }
    
}
